#include "HaD_Badge.h"
#include "bh-badge-animate.h"
//Hint: look in HaD_Badge.h for function and constant definitions
#define MAX_Y 3
#define MAX_X 13

#define GUY_IDLE 0
#define GUY_WALK 1
#define GUY_JUMP 2
#define GUY_DUCK 3
#define GUY_FALL 4
#define GUY_FLOAT 5
#define ENEMY_GROUND 0
#define ENEMY_AIR 1
#define ENEMY_OFFSCREEN 0
#define ENEMY_ONSCREEN 1

uint8_t array[16];
uint16_t score=0;
uint8_t rand_index=0;

char alive=1;
char frame=0;
char guy_x = MAX_X-1;
char guy_y = 0;
char guy_state = GUY_WALK;
char guy_prev_state = GUY_WALK;
char duck_frames = 4;

char enemy1_x = -1;
char enemy2_x = -1;
char enemy3_x = -1;
char enemy1_type = ENEMY_GROUND;
char enemy2_type = ENEMY_AIR;
char enemy1_state = ENEMY_OFFSCREEN;
char enemy2_state = ENEMY_OFFSCREEN;
char enemy3_state = ENEMY_OFFSCREEN;
uint16_t speed = 0;
uint16_t time_delay = 0;

void randomize(){
   uint8_t random = getTime() & 0xFF;
   uint32_t random2 = (random * random) ^ random << 4;
   rand_index = 0;
   array[ 0] = (random + random2) ^ 0xfa;
   array[ 1] = random - 73;
   array[ 2] = random2 % 128;
   array[ 3] = (((random2 >> 4) ^ (random)) - random2) & 0xff;
   array[ 4] = random2 % 200;
   array[ 5] = ((random2 >> 12) ^ random2) & 0xff;
   array[ 6] = (random2 >> 8) & 0xff;
   array[ 7] = random2 & 0xff;
   array[ 8] = random & 0xff;
   array[ 9] = (random ^ random2) & 0xff;
   array[10] = array[7] ^ array[8];
   array[11] = (~array[4] + array[8]) & 0xff;
   array[12] = (random % 127 * random2  % 128) & 0xff;
   array[13] = ~random2 % 255;
   array[14] = ~(random2 >> 7) & 0xff;
   array[15] = (array[3] ^ array[0]) & 0xff;
}

void drawScore(){
    Buffer[7] |= (score&0b10000000);
    Buffer[6] |= (score&0b01000000)<<1;
    Buffer[5] |= (score&0b00100000)<<2;
    Buffer[4] |= (score&0b00010000)<<3;
    Buffer[3] |= (score&0b00001000)<<4;
    Buffer[2] |= (score&0b00000100)<<5;
    Buffer[1] |= (score&0b00000010)<<6;
    Buffer[0] |= (score&0b00000001)<<7;
    if (score%10==0) speed+=25;
}

void drawEnemy1(){
    if (enemy1_x>=0) Buffer[enemy1_x] |= 0b00000011;
    if (enemy1_x<=15) Buffer[enemy1_x+1] |= 0b00000011;
}

void drawEnemy3(){
    if (enemy3_x>=0) Buffer[enemy3_x] |= 0b00000011;
    if (enemy3_x<=15) Buffer[enemy3_x+1] |= 0b00000011;
}
void drawEnemy2(){
    if (enemy2_x>=0) Buffer[enemy2_x] |= 0b00101000;
    if (enemy2_x<=15) Buffer[enemy2_x+1] |= 0b00010000;
}

void drawEnemies(){
    switch (enemy1_state){
        case ENEMY_OFFSCREEN:
        break;
        case ENEMY_ONSCREEN:
            drawEnemy1();
            enemy1_x++;
            if (enemy1_x>15){
                enemy1_x=-1;
                enemy1_state = ENEMY_OFFSCREEN;
                score++;
                if (score%10==0) speed+=25;
            }
        break;
    }
    switch (enemy3_state){
        case ENEMY_OFFSCREEN:
        break;
        case ENEMY_ONSCREEN:
            drawEnemy3();
            enemy3_x++;
            if (enemy3_x>15){
                enemy3_x=-1;
                enemy3_state = ENEMY_OFFSCREEN;
                score++;
                if (score%10==0) speed+=25;
            }
        break;
    }
    switch (enemy2_state){
        case ENEMY_OFFSCREEN:
        break;
        case ENEMY_ONSCREEN:
            drawEnemy2();
            enemy2_x++;
            if (enemy2_x>15){
                enemy2_x=-1;
                enemy2_state = ENEMY_OFFSCREEN;
                score+=2;
                if (score%10==0) speed+=25;
            }
        break;
    }
}

int checkCollision(){
    if ((enemy1_x>11)&&(guy_y<2)&&(enemy1_state==ENEMY_ONSCREEN)) return 1;
    if ((enemy3_x>11)&&(guy_y<2)&&(enemy3_state==ENEMY_ONSCREEN)) return 1;
    if ((enemy2_x>12)&&(guy_state!=GUY_DUCK)&&(enemy2_state==ENEMY_ONSCREEN)) return 1;
    return 0;
}

void drawIdle(){
    Buffer[guy_x] |= 0b00000101<<guy_y;
    Buffer[guy_x+1] |= 0b00001110<<guy_y;
    Buffer[guy_x+2] |= 0b00000101<<guy_y; 

}
void drawDuck(){
    Buffer[guy_x] |= 0b0000011<<guy_y;
    Buffer[guy_x+1] |= 0b00000110<<guy_y;
    Buffer[guy_x+2] |= 0b0000011<<guy_y; 
}

void drawWalk(){
    Buffer[guy_x] |= 0b00000000<<guy_y;
    Buffer[guy_x+1] |= 0b00001111<<guy_y;
    Buffer[guy_x+2] |= 0b00000000<<guy_y;
}
void drawGuy(){
    switch (guy_prev_state){
        case GUY_IDLE:
            drawIdle();
            break;
        case GUY_WALK:
            if (frame==0){
                drawWalk();
                frame++;
            }else{
                drawIdle();
                frame=0;
            }
            break;
        case GUY_JUMP:
            if (guy_y==MAX_Y) guy_state=GUY_FLOAT;
            else if (guy_y==0) guy_y=2;
            else guy_y++;
            drawIdle();
            break;
        case GUY_DUCK:
            if (duck_frames==0) {
                guy_state=GUY_WALK;
                duck_frames=4;
            }
            else duck_frames--;
            drawDuck();
            break;
        case GUY_FALL:
            if (guy_y==0) guy_state=GUY_WALK;
            else guy_y--;
            drawIdle();
            break;
        case GUY_FLOAT:
            guy_state = GUY_FALL;
            drawIdle();
            break;
        default:
            guy_state=GUY_WALK;
    }
    guy_prev_state = guy_state;
}

void moveUp() {
    if (guy_prev_state==GUY_WALK) guy_state=GUY_JUMP;
}

void moveDown() {
    if (guy_prev_state==GUY_WALK||guy_prev_state==GUY_DUCK) guy_state = GUY_DUCK;
    else if ((guy_state==GUY_FLOAT||guy_state==GUY_FALL)&&guy_y>1) guy_y--;
}

void animateBadge(void) {
    
    displayLatch();
    uint32_t lastTime = getTime();

    while(alive>0) {
        //This shows how to use non-blocking getTime() function
        if (getTime() > lastTime+400) {
            lastTime = getTime();   
            displayClear();
            drawGuy();
            drawEnemies();
            drawScore();
            
            //score+=checkCollision();
            if (checkCollision()>0) {
                alive=0;
                break;
            }
        }
        
        //This shows how to get user input
        switch (getControl()) {
            case (ESCAPE):
                displayClose();
                return;
            case (LEFT):
                moveUp();
                break;
            case (RIGHT):
                moveDown();
                break;
            case (UP):
                if (enemy2_state==ENEMY_ONSCREEN&&enemy2_x>6&&enemy1_x>6) enemy3_state = ENEMY_ONSCREEN;
                else enemy2_state = ENEMY_ONSCREEN;
                break;
            case (DOWN):
                enemy1_state = ENEMY_ONSCREEN;
                break;
        }
  /*     
        int i = array[rand_index]>>4;
        
        if (array[i]%2&&enemy1_state==ENEMY_OFFSCREEN){
            enemy1_state = ENEMY_ONSCREEN;
            rand_index++;
        }else if (array[i]%3){
            if ((enemy1_x > 5 || enemy1_x <9)&&enemy2_state==ENEMY_OFFSCREEN) {
                enemy2_state = ENEMY_ONSCREEN; 
                rand_index++;
            }
        }*/
    }
}